import {tickFormat,axisBottom, format, range, select, json, geoPath, geoTransverseMercator, zoom, event, scaleLog, scaleLinear, schemeCategory10, schemeSpectral} from "d3";

var svg = select("svg")

var domain = [1,21375]
var range2 = [0,500]
var colour_range = ["blue", "red"]


var g = svg.append("g")
	.attr("transform","translate(100,100)")


var logScale =  scaleLog().domain(domain).range(range2)
var linearScale = scaleLinear().domain(domain).range(range2)

//Map colours across the range in equal intervals
var num_colours = colour_range.length
var diff = range2[1] - range2[0]

var step = diff / (colour_range.length - 1)
var for_inversion = range(num_colours).map(function(d) {return range2[0] + d*step})
var log_colour_values = for_inversion.map(logScale.invert)


var logColour_scale = scaleLog().domain(log_colour_values).range(colour_range)

var num_rectangles = 100

var step = diff/num_rectangles
var rect_data = range(num_rectangles).map(function(d) {return range2[0] + d*step})

g.selectAll("rect").data(rect_data).enter()
.append("rect")
.attr("x", function(d) {return d})
.attr("y", function(d) {return 100})
.attr("height", function(d) {return 20})
.attr("width", function(d) {return diff/num_rectangles})
.attr("fill", function(d) {
 return logColour_scale(logScale.invert(d))
})


//What number in the domain is half way along the logscale?

var axis = axisBottom(logScale).tickFormat(format("~s"))



g.call(axis)